package com.unitesk.reqcoverage.eclipse;

import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.KeyListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

import com.unitesk.reqcoverage.reqstracer.Collector;

public class RegExpPage extends WizardPage {
  private Text text;
  private Composite container;
  private String defreqexps = "";

  public RegExpPage() {
    super("Regular expression page");
    setTitle("Set regular expression");
    setDescription("Please set regular expression");
  }

  @Override
  public void createControl(Composite parent) {
    container = new Composite(parent, SWT.NULL);
    GridLayout layout = new GridLayout();
    container.setLayout(layout);
    layout.numColumns = 3;
    Label label1 = new Label(container, SWT.NULL);
    label1.setText("Regular expression");

    text = new Text(container, SWT.BORDER);
    text.setText(defreqexps);
    text.addKeyListener(
        new KeyListener() {

          @Override
          public void keyPressed(KeyEvent e) {}

          @Override
          public void keyReleased(KeyEvent e) {
            if (!text.getText().isEmpty()) {
              setPageComplete(true);
            }
          }
        });

    GridData gd = new GridData(GridData.FILL_HORIZONTAL);
    text.setLayoutData(gd);
    // Required to avoid an error in the system
    setControl(container);

    Collector.instance().setProcessReport(false);
  }

  public String getText() {
    return text.getText();
  }

  public void setRegularExpressions(String listToString) {
    defreqexps = listToString;
    if (text != null) {
      text.setText(defreqexps);
      if (!text.getText().isEmpty()) setPageComplete(true);
    }
  }
}
