package com.unitesk.reqcoverage.reqstracer;

import java.util.ArrayList;
import java.util.List;

public class ErrorLog {
  public static class Entry {}

  public static class ExceptionEntry extends Entry {
    protected Throwable err;

    public ExceptionEntry(Throwable err) {
      this.err = err;
    }

    @Override
    public String toString() {
      return "Exception[" + err.getClass().getSimpleName() + ": " + err.getMessage() + "]";
    }
  }

  private ArrayList<Entry> log;

  public ErrorLog() {
    log = new ArrayList<ErrorLog.Entry>();
  }

  public List<Entry> entries() {
    return log;
  }

  public boolean isEmpty() {
    return log.isEmpty();
  }

  public void add(Throwable e) {
    log.add(new ExceptionEntry(e));
  }
}
