package com.unitesk.reqcoverage.tests;

import org.eclipse.jface.wizard.WizardDialog;

import com.unitesk.reqcoverage.eclipse.wizards.NewTestWizard;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.nodetypes.Requirement;
import com.unitesk.requality.nodetypes.TestPurpose;
import com.unitesk.requality.tests.ITestGenerator;
import com.unitesk.requality.tests.OperationResult;
import com.unitesk.requality.tests.TestDialogProvider;

public class ExistingTestGenerator implements ITestGenerator {
  public static final String WIZARD_ID = "com.unitesk.reqcoverage.existingtest";
  private String target = null;

  public ExistingTestGenerator() {
    this(null);
  }

  public ExistingTestGenerator(String targ) {
    target = targ;
  }

  @Override
  public boolean generateTest(TreeNode targetNode, Object dp) {
    WizardDialog wizard = ((TestDialogProvider) dp).getWizard(WIZARD_ID, targetNode);
    if (target != null)
      ((NewTestWizard) ((TestDialogProvider) dp).getLastWizard()).setSelectedId(target);
    OperationResult or = ((TestDialogProvider) dp).openWizard(wizard, WIZARD_ID, targetNode);
    return or.getSucceedFlag();
  }

  @Override
  public boolean isEnabled(TreeNode target) {
    return target.getType().equals(TestPurpose.TYPE_NAME)
        || target.getType().equals(Requirement.TYPE_NAME);
  }
}
